<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>MCUXpresso SDK API Reference Manual: FlexCAN eDMA Driver</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="fs_logo.gif"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">MCUXpresso SDK API Reference Manual
   &#160;<span id="projectnumber">Rev. 0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>API&#160;Reference</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('group__flexcan__edma__driver.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#typedef-members">Typedefs</a>  </div>
  <div class="headertitle">
<div class="title">FlexCAN eDMA Driver<div class="ingroups"><a class="el" href="group__flexcan.html">FlexCAN: Flex Controller Area Network Driver</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<a name="details" id="details"></a><h2 class="groupheader">Overview</h2>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:struct__flexcan__edma__handle"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#struct__flexcan__edma__handle">flexcan_edma_handle_t</a></td></tr>
<tr class="memdesc:struct__flexcan__edma__handle"><td class="mdescLeft">&#160;</td><td class="mdescRight">FlexCAN eDMA handle.  <a href="group__flexcan__edma__driver.html#struct__flexcan__edma__handle">More...</a><br/></td></tr>
<tr class="separator:struct__flexcan__edma__handle"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:ga200b7c77f4d5b5495193e58772e12c68"><td class="memItemLeft" align="right" valign="top">typedef void(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#ga200b7c77f4d5b5495193e58772e12c68">flexcan_edma_transfer_callback_t</a> )(CAN_Type *base, flexcan_edma_handle_t *handle, status_t status, void *userData)</td></tr>
<tr class="memdesc:ga200b7c77f4d5b5495193e58772e12c68"><td class="mdescLeft">&#160;</td><td class="mdescRight">FlexCAN transfer callback function.  <a href="#ga200b7c77f4d5b5495193e58772e12c68">More...</a><br/></td></tr>
<tr class="separator:ga200b7c77f4d5b5495193e58772e12c68"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="member-group"></a>
eDMA transactional</h2></td></tr>
<tr class="memitem:ga1ca334397a0902a09b8b7ddd4a73d87b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#ga1ca334397a0902a09b8b7ddd4a73d87b">FLEXCAN_TransferCreateHandleEDMA</a> (CAN_Type *base, flexcan_edma_handle_t *handle, <a class="el" href="group__flexcan__edma__driver.html#ga200b7c77f4d5b5495193e58772e12c68">flexcan_edma_transfer_callback_t</a> callback, void *userData, <a class="el" href="group__edma.html#structedma__handle__t">edma_handle_t</a> *rxFifoEdmaHandle)</td></tr>
<tr class="memdesc:ga1ca334397a0902a09b8b7ddd4a73d87b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the FlexCAN handle, which is used in transactional functions.  <a href="#ga1ca334397a0902a09b8b7ddd4a73d87b">More...</a><br/></td></tr>
<tr class="separator:ga1ca334397a0902a09b8b7ddd4a73d87b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga153f2e62a0aff73b242fee109896c34e"><td class="memItemLeft" align="right" valign="top">status_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#ga153f2e62a0aff73b242fee109896c34e">FLEXCAN_TransferReceiveFifoEDMA</a> (CAN_Type *base, flexcan_edma_handle_t *handle, <a class="el" href="group__flexcan__driver.html#structflexcan__fifo__transfer__t">flexcan_fifo_transfer_t</a> *xfer)</td></tr>
<tr class="memdesc:ga153f2e62a0aff73b242fee109896c34e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receives the CAN Message from the Rx FIFO using eDMA.  <a href="#ga153f2e62a0aff73b242fee109896c34e">More...</a><br/></td></tr>
<tr class="separator:ga153f2e62a0aff73b242fee109896c34e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga518cce21e8dde19dc32b21a68c549b1b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#ga518cce21e8dde19dc32b21a68c549b1b">FLEXCAN_TransferAbortReceiveFifoEDMA</a> (CAN_Type *base, flexcan_edma_handle_t *handle)</td></tr>
<tr class="memdesc:ga518cce21e8dde19dc32b21a68c549b1b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Aborts the receive process which used eDMA.  <a href="#ga518cce21e8dde19dc32b21a68c549b1b">More...</a><br/></td></tr>
<tr class="separator:ga518cce21e8dde19dc32b21a68c549b1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<hr/><h2 class="groupheader">Data Structure Documentation</h2>
<a name="struct__flexcan__edma__handle" id="struct__flexcan__edma__handle"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct _flexcan_edma_handle</td>
        </tr>
      </table>
</div><div class="memdoc">
<div class="textblock"></div><table class="memberdecls">
<tr><td colspan="2"><h3>Data Fields</h3></td></tr>
<tr class="memitem:a63bbb14985ea667bb86d933782244ebe"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__flexcan__edma__driver.html#ga200b7c77f4d5b5495193e58772e12c68">flexcan_edma_transfer_callback_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#a63bbb14985ea667bb86d933782244ebe">callback</a></td></tr>
<tr class="memdesc:a63bbb14985ea667bb86d933782244ebe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Callback function.  <a href="#a63bbb14985ea667bb86d933782244ebe">More...</a><br/></td></tr>
<tr class="separator:a63bbb14985ea667bb86d933782244ebe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8408c788bc9497c7a74811940a28bce7"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#a8408c788bc9497c7a74811940a28bce7">userData</a></td></tr>
<tr class="memdesc:a8408c788bc9497c7a74811940a28bce7"><td class="mdescLeft">&#160;</td><td class="mdescRight">FlexCAN callback function parameter.  <a href="#a8408c788bc9497c7a74811940a28bce7">More...</a><br/></td></tr>
<tr class="separator:a8408c788bc9497c7a74811940a28bce7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a923894ca8505812ac61ad5632677a7d2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__edma.html#structedma__handle__t">edma_handle_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#a923894ca8505812ac61ad5632677a7d2">rxFifoEdmaHandle</a></td></tr>
<tr class="memdesc:a923894ca8505812ac61ad5632677a7d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">The EDMA Rx FIFO channel used.  <a href="#a923894ca8505812ac61ad5632677a7d2">More...</a><br/></td></tr>
<tr class="separator:a923894ca8505812ac61ad5632677a7d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af08257e6fde0f8f49d152ab07264dfd3"><td class="memItemLeft" align="right" valign="top">volatile uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__flexcan__edma__driver.html#af08257e6fde0f8f49d152ab07264dfd3">rxFifoState</a></td></tr>
<tr class="memdesc:af08257e6fde0f8f49d152ab07264dfd3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Rx FIFO transfer state.  <a href="#af08257e6fde0f8f49d152ab07264dfd3">More...</a><br/></td></tr>
<tr class="separator:af08257e6fde0f8f49d152ab07264dfd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h4 class="groupheader">Field Documentation</h4>
<a class="anchor" id="a63bbb14985ea667bb86d933782244ebe"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__flexcan__edma__driver.html#ga200b7c77f4d5b5495193e58772e12c68">flexcan_edma_transfer_callback_t</a> flexcan_edma_handle_t::callback</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a8408c788bc9497c7a74811940a28bce7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* flexcan_edma_handle_t::userData</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a923894ca8505812ac61ad5632677a7d2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__edma.html#structedma__handle__t">edma_handle_t</a>* flexcan_edma_handle_t::rxFifoEdmaHandle</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="af08257e6fde0f8f49d152ab07264dfd3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">volatile uint8_t flexcan_edma_handle_t::rxFifoState</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>

</div>
</div>
<h2 class="groupheader">Typedef Documentation</h2>
<a class="anchor" id="ga200b7c77f4d5b5495193e58772e12c68"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void(* flexcan_edma_transfer_callback_t)(CAN_Type *base, flexcan_edma_handle_t *handle, status_t status, void *userData)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga1ca334397a0902a09b8b7ddd4a73d87b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FLEXCAN_TransferCreateHandleEDMA </td>
          <td>(</td>
          <td class="paramtype">CAN_Type *&#160;</td>
          <td class="paramname"><em>base</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">flexcan_edma_handle_t *&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__flexcan__edma__driver.html#ga200b7c77f4d5b5495193e58772e12c68">flexcan_edma_transfer_callback_t</a>&#160;</td>
          <td class="paramname"><em>callback</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>userData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__edma.html#structedma__handle__t">edma_handle_t</a> *&#160;</td>
          <td class="paramname"><em>rxFifoEdmaHandle</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">base</td><td>FlexCAN peripheral base address. </td></tr>
    <tr><td class="paramname">handle</td><td>Pointer to flexcan_edma_handle_t structure. </td></tr>
    <tr><td class="paramname">callback</td><td>The callback function. </td></tr>
    <tr><td class="paramname">userData</td><td>The parameter of the callback function. </td></tr>
    <tr><td class="paramname">rxFifoEdmaHandle</td><td>User-requested DMA handle for Rx FIFO DMA transfer. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga153f2e62a0aff73b242fee109896c34e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">status_t FLEXCAN_TransferReceiveFifoEDMA </td>
          <td>(</td>
          <td class="paramtype">CAN_Type *&#160;</td>
          <td class="paramname"><em>base</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">flexcan_edma_handle_t *&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__flexcan__driver.html#structflexcan__fifo__transfer__t">flexcan_fifo_transfer_t</a> *&#160;</td>
          <td class="paramname"><em>xfer</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function receives the CAN Message using eDMA. This is a non-blocking function, which returns right away. After the CAN Message is received, the receive callback function is called.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">base</td><td>FlexCAN peripheral base address. </td></tr>
    <tr><td class="paramname">handle</td><td>Pointer to flexcan_edma_handle_t structure. </td></tr>
    <tr><td class="paramname">xfer</td><td>FlexCAN Rx FIFO EDMA transfer structure, see <a class="el" href="group__flexcan__driver.html#structflexcan__fifo__transfer__t" title="FlexCAN Rx FIFO transfer. ">flexcan_fifo_transfer_t</a>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kStatus_Success</td><td>if succeed, others failed. </td></tr>
    <tr><td class="paramname">kStatus_FLEXCAN_RxFifoBusy</td><td>Previous transfer ongoing. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga518cce21e8dde19dc32b21a68c549b1b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FLEXCAN_TransferAbortReceiveFifoEDMA </td>
          <td>(</td>
          <td class="paramtype">CAN_Type *&#160;</td>
          <td class="paramname"><em>base</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">flexcan_edma_handle_t *&#160;</td>
          <td class="paramname"><em>handle</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function aborts the receive process which used eDMA.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">base</td><td>FlexCAN peripheral base address. </td></tr>
    <tr><td class="paramname">handle</td><td>Pointer to flexcan_edma_handle_t structure. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
